#pragma once

#include <vector>
#include <cstdlib>
#include "base.h"

using namespace std;

class match_testcase_adversary : public testcase_adversary {
  public:
    match_testcase_adversary(vector<int> p, vector<int> &b): p(p), b(b) {}
  protected:
    int write(int G, int P, int B) {
      int t = p.empty() ? B : p[P % p.size()];
      if (B != t && g >= G) {
        g = 0;
        b.push_back(t);
        return t;
      } else {
        g++;
        b.push_back(B);
        return B;
      }
    }
  private:
    int g = 2;
    vector<int> p, &b;
};

class match_adversary : public adversary {
  public:
    match_adversary(int n): n(n) {}
    pair<int, int> testcase(int T, int t, int MAX_N) {
      if (t == 0)
        for (int i = 0; i < n; i++)
          x.push_back(rand() % MAX_N + 1);
      int X = x[t % x.size()];
      swap(p, b);
      b.clear();
      testcaseAdversary = new match_testcase_adversary(p, b);
      return {MAX_N, X};
    }
  private:
    int n;
    vector<int> x, p, b;
};